169.Majority Element (法1排序法2多数投票)

Given an array of size n, find the majority element. Themajority element is the element that appears more than ? n/2
? times.

You may assume that the array is non-empty and the majority element alwaysexist in the array.

Credits:

Special thanks to @ts for adding this problem and creating all testcases.

HideTags

Divide and Conquer Array Bit
Manipulation

#pragma once
#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

//法1:排序,返回中间数
int majorityElement1(vector<int> &num)
{
	sort(num.begin(), num.end());
	return num[num.size() / 2];
}

//法2:多数投票,每找到一对不同的数,就成对删除。
int majorityElement2(vector<int> &num)
{
	int count = 1;
	int element = num[0];//题设num非空
	for (int i = 1; i < num.size(); i++)
	{
		if (count == 0)
		{
			element = num[i];
			count = 1;
			continue;
		}
		if (num[i] == element)
			count++;
		else
			count--;
	}
	return element;
}
void main()
{
	vector<int> v = { 1,1,1,1,2,2,2 };
	//vector<int>::iterator begain, end;

	/*sort(v.begin(), v.end());
	for (int i = 0; i < v.size(); i++)
	cout << v[i] << ' ';*/
	cout << majorityElement2(v) << endl;
	system("pause");
}
时间: 2024-11-10 01:18:53

169.Majority Element (法1排序法2多数投票)的相关文章

169. Majority Element(C++)

169. Majority Element Given an array of size n, find the majority element. The majority element is the element that appears more than ⌊ n/2 ⌋ times. You may assume that the array is non-empty and the majority element always exist in the array. 题目大意:

Leetcode#169. Majority Element(求众数)

题目描述 给定一个大小为 n 的数组,找到其中的众数.众数是指在数组中出现次数大于 ? n/2 ? 的元素. 你可以假设数组是非空的,并且给定的数组总是存在众数. 示例 1: 输入: [3,2,3] 输出: 3 示例 2: 输入: [2,2,1,1,1,2,2] 输出: 2 思路 思路一: 利用哈希表的映射,储存数组中的数字以及它们出现的次数,当众数出现时,返回这个数字. 思路二: 因为众数是出现次数大于n/2的数字,所以排序之后中间的那个数字一定是众数.即nums[n/2]为众数.但是在计算比

169. Majority Element &amp;&amp; 229. Majority Element II

169. Majority Element Given an array of size n, find the majority element. The majority element is the element that appears more than ⌊ n/2 ⌋ times. You may assume that the array is non-empty and the majority element always exist in the array. Hide T

LeetCode Javascript实现 169. Majority Element

169. Majority Element /** * @param {number[]} nums * @return {number} */ var majorityElement = function(nums) { var hash = {}; var y=-1,z; //注意这里的方括号,利用变量访问对象属性时要用方括号 for(var i=0;i<=nums.length-1;i++){ if(hash[nums[i]]){ hash[nums[i]]++; }else{ hash[

leetCode 169. Majority Element 数组

169. Majority Element Given an array of size n, find the majority element. The majority element is the element that appears more than  n/2  times. You may assume that the array is non-empty and the majority element always exist in the array. 思路1: 使用m

169. Majority Element - LeetCode

Question 169. Majority Element Solution 思路:构造一个map存储每个数字出现的次数,然后遍历map返回出现次数大于数组一半的数字. 还有一种思路是:对这个数组排序,次数超过n/2的元素必然在中间. Java实现: public int majorityElement(int[] nums) { Map<Integer, Integer> countMap = new HashMap<>(); for (int num : nums) { In

[Lintcode]46. Majority Element/[Leetcode]169. Majority Element

46. Majority Element/[169. Majority Element(https://leetcode.com/problems/majority-element/) 本题难度: Easy Topic: Greedy Description Given an array of integers, the majority number is the number that occurs more than half of the size of the array. Find

刷题169. Majority Element

一.题目说明 题目169. Majority Element,给定n个数的数组,返回出现次数超过半数的元素. 二.我的解答 这个题目用一个map,遍历一遍数组,计数每个元素出现的次数. class Solution{ public: int majorityElement(vector<int>& nums){ unordered_map<int,int> ump; int maxNum = 0; int maxCount = 0; for(int i=0;i<num

137.Single Number II(法1排序法2STL容器map哈希法3位运算法4改进的位运算)

Given an array of integers, every element appears three timesexcept for one. Find that single one. Note: Your algorithm should have a linear runtime complexity. Could you implement itwithout using extra memory? HideTags Bit Manipulation #pragma once